## eckit 1.4.7

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### dependencies and options

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()
### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    REQUIRED_PACKAGES "LEXYACC" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### LAPACK

if( ECKIT_HAVE_MKL )
    set( ECKIT_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

if( XXHASH_FOUND )
  ecbuild_info("xxHash -- libs [${XXHASH_LIBRARIES}] incs [${XXHASH_INCLUDE_DIRS}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### async io support

find_package( AIO )
set_package_properties( AIO PROPERTIES TYPE RECOMMENDED PURPOSE "support for asynchronous IO" )

### c math library, needed when including "math.h"

find_package( CMath )

###############################################################################
# checks

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_ECKIT_MPI )
  list( APPEND ECKIT_LIBRARIES eckit_mpi )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README.md NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

### sources

if( HAVE_EXPERIMENTAL )
  add_subdirectory( experimental )
endif()

add_subdirectory( eckit  )

add_subdirectory( tools )

add_subdirectory( sandbox )

=== tests/container/CMakeLists.txt ===
ecbuild_add_test( TARGET   eckit_test_container_sharedmemarray
                  SOURCES  test_sharedmemarray.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_btree
                  SOURCES  test_btree.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_bloomfilter
                  SOURCES  test_bloomfilter.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_trie
                  SOURCES  test_trie.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_densemap
                  SOURCES  test_densemap.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_denseset
                  SOURCES  test_denseset.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_cache_lru
                  SOURCES  test_cache_lru.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_container_benchmark_densemap
                  SOURCES  benchmark_densemap.cc
                  LIBS     eckit )

=== tests/linalg/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

ecbuild_add_test( TARGET   eckit_test_linalg_factory
                  ARGS     --log_level=message
                  SOURCES  test_la_factory.cc
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET   eckit_test_linalg_linalg
                  ARGS     --log_level=message
                  SOURCES  test_la_linalg.cc util.h
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_armadillo
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_ARMADILLO
                  ARGS       --log_level=message -linearAlgebraBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET     eckit_test_linalg_linalg_cuda
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_CUDA
                  ARGS       --log_level=message --catch_system_errors=no -linearAlgebraBackend cuda )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_eigen
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_EIGEN
                  ARGS       --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_lapack
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_LAPACK
                  ARGS       --log_level=message -linearAlgebraBackend lapack )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_mkl
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_MKL
                  ARGS       --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET     eckit_test_linalg_linalg_viennacl
                  COMMAND    eckit_test_linalg_linalg
                  CONDITION  ECKIT_HAVE_VIENNACL
                  ARGS       --log_level=message -linearAlgebraBackend viennacl )

ecbuild_add_test( TARGET   eckit_test_linalg_sparse
                  ARGS     --log_level=message
                  SOURCES  test_la_sparse.cc util.h
                  LIBS     eckit_linalg )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_armadillo
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_ARMADILLO
                  ARGS       --log_level=message -linearAlgebraBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET     eckit_test_linalg_sparse_cuda
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_CUDA
                  ARGS       --log_level=message --catch_system_errors=no -linearAlgebraBackend cuda )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_eigen
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_EIGEN
                  ARGS       --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_lapack
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_LAPACK
                  ARGS       --log_level=message -linearAlgebraBackend lapack )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_mkl
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_MKL
                  ARGS       --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET     eckit_test_linalg_sparse_viennacl
                  COMMAND    eckit_test_linalg_sparse
                  CONDITION  ECKIT_HAVE_VIENNACL
                  ARGS       --log_level=message -linearAlgebraBackend viennacl )

ecbuild_add_test( TARGET   eckit_test_linalg_streaming
                  ARGS     --log_level=message
                  SOURCES  test_la_streaming.cc util.h
                  LIBS     eckit_linalg )

=== tests/mpi/CMakeLists.txt ===
ecbuild_add_test(
    TARGET      eckit_test_mpi
    SOURCES     eckit_test_mpi.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

 ecbuild_add_test(
    TARGET      eckit_test_mpi_addcomm
    SOURCES     eckit_test_mpi_addcomm.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

ecbuild_add_test(
    TARGET      eckit_test_mpi_splitcomm
    SOURCES     eckit_test_mpi_splitcomm.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

ecbuild_add_test(
    TARGET      eckit_test_mpi_objserialisation
    SOURCES     eckit_test_mpi_objserialisation.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

=== tests/value/CMakeLists.txt ===
ecbuild_add_library( TARGET     eckit_test_value_custom_params TYPE SHARED
                     NOINSTALL
                     SOURCES    AnyKeyParams.cc
                     LIBS       eckit )

ecbuild_add_test( TARGET   eckit_test_value_value_params
                  SOURCES  test_value_params.cc
                  LIBS     eckit eckit_test_value_custom_params )

ecbuild_add_test( TARGET   eckit_test_value_value_properties
                  SOURCES  test_value_properties.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_value_value_const
                  SOURCES  test_value_const.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_value_value_typeordering
                  SOURCES  test_value_typeordering.cc
                  LIBS     eckit )

foreach( valueType nil boolean integer double string valuemap valuelist date orderedmap )
   ecbuild_add_test( TARGET   eckit_test_value_value_${valueType}
                     SOURCES  test_value_${valueType}.cc
                     LIBS     eckit )
endforeach()

if( CMAKE_CXX_COMPILER_ID MATCHES "Cray" )
   # Disable warnings for test_value_integer due to following:
   #    "Integer conversion resulted in a change of sign."
   set_source_files_properties(test_value_integer.cc PROPERTIES COMPILE_FLAGS "-hmsglevel_4" )
endif()

=== src/eckit/cmd/CMakeLists.txt ===
list( APPEND eckit_cmd_srcs
cmdlib.h
AliasCmd.cc
AliasCmd.h
Arg.cc
Arg.h
CmdApplication.cc
CmdApplication.h
CmdArg.cc
CmdArg.h
CmdParser.cc
CmdParser.h
CmdResource.cc
CmdResource.h
ConfigCmd.cc
ConfigCmd.h
DirCmd.cc
DirCmd.h
EchoCmd.cc
EchoCmd.h
EnvironmentCmd.cc
EnvironmentCmd.h
ExportCmd.cc
ExportCmd.h
JSONCmd.cc
JSONCmd.h
HistoryCmd.cc
HistoryCmd.h
KillCmd.cc
KillCmd.h
LockCmd.cc
LockCmd.h
ManCmd.cc
ManCmd.h
MemoryCmd.cc
MemoryCmd.h
PsCmd.cc
PsCmd.h
QuitCmd.cc
QuitCmd.h
RemoteCmd.cc
RemoteCmd.h
RemoteCommandable.cc
RemoteCommandable.h
RemoteCommander.cc
RemoteCommander.h
RemoteCommandUser.cc
RemoteCommandUser.h
SleepCmd.cc
SleepCmd.h
StartCmd.cc
StartCmd.h
StatusCmd.cc
StatusCmd.h
StopCmd.cc
StopCmd.h
TailCmd.cc
TailCmd.h
TermBuf.cc
TermBuf.h
term.c
UpTimeCmd.cc
UpTimeCmd.h
UserInput.h
UserInput.cc
)

ecbuild_generate_yy( YYPREFIX eckit_cmd_
                     YACC cmdsy
                     LEX  cmdsl
                     DEPENDANT CmdParser.cc )

if( NOT ENABLE_WARNINGS )
  # Warnings present in autogenerated files based on cmdsy and cmdsl
  list( APPEND suppress_warnings
    $<$<CXX_COMPILER_ID:GNU>:-Wno-unused-function>
    $<$<CXX_COMPILER_ID:GNU>:-Wno-sign-compare>
    $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-register>
  )
  set_source_files_properties( CmdParser.cc PROPERTIES COMPILE_OPTIONS "${suppress_warnings}" )
endif()

ecbuild_add_library( TARGET             eckit_cmd TYPE SHARED
                     INSTALL_HEADERS    LISTED
                     SOURCES            ${eckit_cmd_srcs}
                     HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/cmd
                     INCLUDES           ${CURSES_INCLUDE_DIR}
                     LIBS               eckit ${CURSES_LIBRARIES} )

=== src/eckit/geometry/CMakeLists.txt ===
list( APPEND eckit_geometry_srcs
EllipsoidOfRevolution.cc
EllipsoidOfRevolution.h
GreatCircle.cc
GreatCircle.h
KPoint.cc
KPoint.h
Point2.cc
Point2.h
Point3.cc
Point3.h
Polygon.cc
Polygon.h
Sphere.cc
Sphere.h
SphereT.h
UnitSphere.h
)

ecbuild_add_library(TARGET eckit_geometry TYPE SHARED
					INSTALL_HEADERS ALL
					HEADER_DESTINATION
						${INSTALL_INCLUDE_DIR}/eckit/geometry
					SOURCES
						${eckit_geometry_srcs}
					LIBS
						eckit  )

=== src/eckit/maths/CMakeLists.txt ===
list( APPEND eckit_maths_lib_srcs
Eigen.h
Lapack.h
Lapack.cc
Matrix.h
MatrixEigen.h
MatrixLapack.h
)

ecbuild_add_library( TARGET              eckit_maths TYPE SHARED
                     INSTALL_HEADERS     ALL
                     HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/maths
                     SOURCES             ${eckit_maths_lib_srcs}
                     INCLUDES            "${EIGEN3_INCLUDE_DIR}"
                     LIBS                eckit "${LAPACK_LIBRARIES}" "${BLAS_LIBRARIES}" )

=== src/eckit/mpi/CMakeLists.txt ===
list( APPEND eckit_mpi_srcs
Buffer.h
Comm.cc
Comm.h
DataType.cc
DataType.h
Operation.cc
Operation.h
Request.cc
Request.h
Serial.cc
Serial.h
SerialData.h
SerialStatus.cc
SerialStatus.h
SerialRequest.cc
SerialRequest.h
Status.cc
Status.h
)

if( HAVE_MPI )

    list( APPEND eckit_mpi_srcs
        Parallel.cc
        Parallel.h
        ParallelStatus.cc
        ParallelStatus.h
        ParallelRequest.cc
        ParallelRequest.h
        )

    set(eckit_mpi_defs ${MPI_C_DEFINITIONS} )
    set(eckit_mpi_incs ${MPI_C_INCLUDE_PATH} )
    set(eckit_mpi_libs ${MPI_C_LIBRARIES} )
endif()

ecbuild_add_library( TARGET eckit_mpi TYPE SHARED
                     INSTALL_HEADERS ALL
                     HEADER_DESTINATION
                         ${INSTALL_INCLUDE_DIR}/eckit/mpi
                     SOURCES
                         ${eckit_mpi_srcs}
                     DEFINITIONS
                         "${eckit_mpi_defs}"
                     INCLUDES
                         "${eckit_mpi_incs}"
                     LIBS
                         eckit ${eckit_mpi_libs} )

=== src/eckit/option/CMakeLists.txt ===
ecbuild_add_library( TARGET eckit_option TYPE SHARED

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/option

	SOURCES
        FactoryOption.cc
        FactoryOption.h
        Option.cc
        Option.h
        Separator.cc
        Separator.h
        SimpleOption.cc
        SimpleOption.h
        VectorOption.cc
        VectorOption.h
        CmdArgs.cc
        CmdArgs.h

    TEMPLATES
        FactoryOption.cc
        VectorOption.cc
        SimpleOption.cc

    LIBS eckit )

=== src/eckit/sql/CMakeLists.txt ===
list( APPEND eckit_sql_lib_srcs

#SQLMATCHSubquerySession.h
#SQLMATCHSubquerySession.cc
#SQLMATCHSubquerySessionOutput.h
#SQLMATCHSubquerySessionOutput.cc
Environment.cc
Environment.h
SQLBitColumn.cc
SQLBitColumn.h
SQLColumn.cc
SQLColumn.h
SQLDatabase.cc
SQLDatabase.h
SQLDistinctOutput.cc
SQLDistinctOutput.h
SQLOrderOutput.cc
SQLOrderOutput.h
SQLOutput.cc
SQLOutput.h
SQLOutputConfig.cc
SQLOutputConfig.h
SQLParser.cc
SQLParser.h
SelectOneTable.cc
SelectOneTable.h
SQLSelect.cc
SQLSelect.h
SQLSelectFactory.cc
SQLSelectFactory.h
SQLSession.cc
SQLSession.h
SQLSimpleOutput.cc
SQLSimpleOutput.h
SQLStatement.cc
SQLStatement.h
SQLTable.cc
SQLTable.h
SQLTableFactory.cc
SQLTableFactory.h
SQLTypedefs.h

SchemaAnalyzer.cc
SchemaAnalyzer.h
SchemaComponents.cc
SchemaComponents.h

expression/BitColumnExpression.cc
expression/BitColumnExpression.h
expression/ColumnExpression.cc
expression/ColumnExpression.h
expression/ConstantExpression.cc
expression/ConstantExpression.h
expression/NumberExpression.cc
expression/NumberExpression.h
expression/ParameterExpression.cc
expression/ParameterExpression.h
expression/StringExpression.cc
expression/StringExpression.h
expression/SQLExpression.cc
expression/SQLExpression.h
expression/SQLExpressions.cc
expression/SQLExpressions.h
expression/ShiftedColumnExpression.cc
expression/ShiftedColumnExpression.h
expression/SQLExpressionEvaluated.cc
expression/SQLExpressionEvaluated.h
expression/OrderByExpressions.cc
expression/OrderByExpressions.h

expression/function/piconst.h
expression/function/DoubleFunctions.cc
expression/function/EqRegionCache.cc
expression/function/EqRegionCache.h
expression/function/RggRegionCache.cc
expression/function/RggRegionCache.h
expression/function/RegionCache.cc
expression/function/RegionCache.h
expression/function/FunctionExpression.cc
expression/function/FunctionExpression.h
expression/function/FunctionAND.cc
expression/function/FunctionAND.h
expression/function/FunctionAVG.cc
expression/function/FunctionAVG.h
expression/function/FunctionCOUNT.cc
expression/function/FunctionCOUNT.h
expression/function/FunctionDOTP.cc
expression/function/FunctionDOTP.h
expression/function/FunctionEQ.cc
expression/function/FunctionEQ.h
expression/function/FunctionRLIKE.cc
expression/function/FunctionRLIKE.h
#expression/function/FunctionMATCH.h
#expression/function/FunctionMATCH.cc
expression/function/FunctionFactory.cc
expression/function/FunctionFactory.h
expression/function/FunctionIN.cc
expression/function/FunctionIN.h
expression/function/FunctionIntegerExpression.cc
expression/function/FunctionIntegerExpression.h
expression/function/FunctionJOIN.cc
expression/function/FunctionJOIN.h
expression/function/FunctionJULIAN.cc
expression/function/FunctionJULIAN.h
expression/function/FunctionJULIAN_SECONDS.cc
expression/function/FunctionJULIAN_SECONDS.h
expression/function/FunctionMAX.cc
expression/function/FunctionMAX.h
expression/function/FunctionMIN.cc
expression/function/FunctionMIN.h
expression/function/FunctionFIRST.cc
expression/function/FunctionFIRST.h
expression/function/FunctionLAST.cc
expression/function/FunctionLAST.h
expression/function/FunctionNORM.cc
expression/function/FunctionNORM.h
expression/function/FunctionNOT_IN.cc
expression/function/FunctionNOT_IN.h
expression/function/FunctionNOT_NULL.cc
expression/function/FunctionNOT_NULL.h
expression/function/FunctionNULL.cc
expression/function/FunctionNULL.h
expression/function/FunctionNVL.cc
expression/function/FunctionNVL.h
expression/function/FunctionOR.cc
expression/function/FunctionOR.h
expression/function/FunctionRMS.cc
expression/function/FunctionRMS.h
expression/function/FunctionROWNUMBER.cc
expression/function/FunctionROWNUMBER.h
expression/function/FunctionSTDEV.cc
expression/function/FunctionSTDEV.h
expression/function/FunctionSUM.cc
expression/function/FunctionSUM.h
expression/function/FunctionTDIFF.cc
expression/function/FunctionTDIFF.h
expression/function/FunctionTHIN.cc
expression/function/FunctionTHIN.h
expression/function/FunctionTIMESTAMP.cc
expression/function/FunctionTIMESTAMP.h
expression/function/FunctionVAR.cc
expression/function/FunctionVAR.h

type/SQLBit.cc
type/SQLBit.h
type/SQLBitfield.cc
type/SQLBitfield.h
type/SQLDouble.cc
type/SQLDouble.h
type/SQLInt.cc
type/SQLInt.h
type/SQLReal.cc
type/SQLReal.h
type/SQLString.cc
type/SQLString.h
type/SQLType.cc
type/SQLType.h
)


ecbuild_generate_yy( YYPREFIX           eckit_sql_
                     YACC               sqly
                     LEX                sqll
                     FLEX_FLAGS         "-d"
                     DEPENDANT          SQLParser.cc )

if( NOT ENABLE_WARNINGS )
    # Warnings present in autogenerated files based on sqly and sqll
    list( APPEND suppress_warnings
      $<$<CXX_COMPILER_ID:GNU>:-Wno-unused-function>
      $<$<CXX_COMPILER_ID:GNU>:-Wno-sign-compare>
      $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-register>
    )
    set_source_files_properties( SQLParser.cc PROPERTIES COMPILE_OPTIONS "${suppress_warnings}" )
endif()

ecbuild_add_library( TARGET              eckit_sql TYPE SHARED
                     INSTALL_HEADERS     ALL
                     HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/sql
                     SOURCES             ${eckit_sql_lib_srcs}
                     TEMPLATES
                                         SQLIteratorOutput.cc
                                         expression/ShiftedColumnExpression.cc
                     LIBS                eckit )

# Disable all warnings for PGI compiler as it is overzealous and cherry-picking is not possible
target_compile_options( eckit_sql PRIVATE $<$<CXX_COMPILER_ID:PGI>:-w> )

=== debian/changelog ===
eckit (1.4.7-7build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:03:25 +0100

eckit (1.4.7-7) unstable; urgency=medium

  * libeckit-dev now depends on libaec-dev because of deps in the 
    interface blocks in Cmake files (now AEC support enabled)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 Jan 2020 15:53:05 +0000

eckit (1.4.7-6) unstable; urgency=medium

  * Don't use RADOS on mipsel; not available 
  * libeckit-dev now depends on libeigen3-dev because of deps in the 
    interface blocks in Cmake files

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 Jan 2020 09:33:20 +0000

eckit (1.4.7-5) unstable; urgency=medium

  * Don't use RADOS on alpha, hpaa, powerpc
  * hurd.patch: Add PATH_MAX as needed
  * aec.patch: Add FindAEC.cmake to discover AEC

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Jan 2020 15:18:25 +0000

eckit (1.4.7-4) unstable; urgency=medium

  * Use openblas on archs where it is available, else reference libblas-dev,
    liblapack-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Jan 2020 13:39:00 +0000

eckit (1.4.7-3) unstable; urgency=medium

  * libeckit-dev also needs to depend on  libssl-dev,
    libcurl4-gnutls-dev,  libxxhash-dev,  libsnappy-dev,  liblz4-dev,
    libbz2-dev, because of cmake interface deps
  * Ditto with openblas and alternatives.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 04 Jan 2020 10:47:42 +0000

eckit (1.4.7-2) unstable; urgency=medium

  * libeckit-dev needs to depend on libopenmpi-dev.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 04 Jan 2020 09:07:50 +0000

eckit (1.4.7-1) unstable; urgency=medium

  * New upstream release
  * Set AEC_INCLUDE_DIR to discover AEC
  * Use openblas-dev for blas, lapack

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 31 Dec 2019 09:02:15 +0000

eckit (1.4.2-3) unstable; urgency=medium

  * Make dependency RADOS optional on minor archs.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 22 Oct 2019 13:52:11 +0100

eckit (1.4.2-2) unstable; urgency=medium

  * Tests disabled in this release
  * -dev pkg depends on -utils for eckit_version
  * include files in /usr/include/$multiarch

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 16 Oct 2019 11:37:29 +0100

eckit (1.4.2-1) unstable; urgency=medium

  * New upstream release
  * Correct homepage and ecKit descriptions
  * Correct VCS link
  * Patch: Include test data rather than download.
  * Ship libeckit_sql.so.0d accidentally excluded
  * Add Breaks/Replaces on odb-api packages that used to supply 
    eckit before the refactoring
  * Build-Depend on flex, bison, libaec-dev, libeigen3-dev,
    mpi-default-dev, doxygen, liblz4-dev, libbz2-dev, libsnappy-dev,
    libncurses-dev, libxxhash-dev, librados-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Oct 2019 07:15:48 +0100

eckit (1.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #935785)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Oct 2019 16:10:53 +0100

=== debian/control ===
Source: eckit
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  dh-buildinfo, 
  ecbuild,
  chrpath,
  flex,
  bison,
  libopenblas-dev [ amd64 arm64 armhf i386 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386 !riscv64 !sh4 !ia64 !alpha !hppa !powerpc !mipsel] ,
  libbz2-dev,
  liblz4-dev,
  libeigen3-dev,
  libsnappy-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev,
  libncurses-dev
Standards-Version: 4.4.1.0
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org:/science-team/eckit.git

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libodb-api-dev ( << 0.18.1-8)
Replaces: libodb-api-dev ( << 0.18.1-8)
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  libopenmpi-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 armhf i386 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libodb-api-0d ( << 0.18.1-8)
Replaces: libodb-api-0d ( << 0.18.1-8)
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Breaks: libodb-api-bin ( << 0.18.1-8)
Replaces: libodb-api-bin ( << 0.18.1-8)
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

AUTOGENERATED:= libeckit-dev.install libeckit0d.install libeckit-dev.links

include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

BUILD_FLAGS = \
	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DSKIP_RPATH=On 

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -rf debian/build-*

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ;  \
                done
	dh_auto_configure --  ${BUILD_FLAGS} 
	( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	@echo Tests disabled in this release

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*.so.0d
	mkdir -p $(TMPDIR)/$(LIBDIR)/cmake/eckit
	install $(TMPDIR)/usr/lib/cmake/eckit/* $(TMPDIR)/$(LIBDIR)/cmake/eckit
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	cat $(TMPDIR)/usr/lib/cmake/eckit/eckit-import.cmake \
		| sed -e 's%/usr/bin/python %/usr/bin/python3 %g' \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-config.cmake \
		| sed -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  \
		| sed -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g'  \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-targets-none.cmake \
		| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-targets.cmake \
		| sed -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' \
		| sed -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*
